## initramfs-tools 0.149ubuntu2

=== debian/changelog ===
initramfs-tools (0.149ubuntu2) questing; urgency=medium

  * Revert "Avoid updating the initramfs twice for some cases" (LP: #2115490)
  * Let linux-firmware updates trigger the initramfs-tools autopkgtest
    (LP: #2116067)

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 07 Jul 2025 20:46:18 +0200

initramfs-tools (0.149ubuntu1) questing; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Use 3cpio for unmkinitramfs/lsinitramfs if available (for massive speedup)
      and let initramfs-tools-core suggest 3cpio
    - Harmonize kernel module installation with dracut's behavior:
      - Do not install ARM/RISCV specific modules on other architectures.
    - Revert "autopkgtest: Fix test failure when built-in drivers request
      firmware". This workaround is not needed on Ubuntu.
    - support mounting of loopback devices via loop*= parameters
    - Add vfat and nls modules to the initramfs.
    - Drop hooks/keymap, scripts/init-top/keymap, and associated code;
      console-setup takes care of this in Ubuntu.
    - Allow scripts and hooks to specify OPTION=VAR, and unless VAR is set to
      something other than "n", the script will not be included.
    - Add a new wait-for-root binary to the initramfs-tools-bin package that
      uses libudev to wait for udev to create the udev device, or wait for
      udev to finish processing if we catch it in the act, and returns the
      filesystem type as already probed by udev.
    - Automatically blacklist vga16fb when vga= or video= specified on kernel
      command-line.
    - Add hwaddr= alias for BOOTIF= for compatibility.
    - Set hostname at boot, for the benefit of mdadm autoassembly.
    - Add Hyper-V paravirtualised device drivers to the initramfs to allow
      booting of stock images in a Hyper-V guest.
    - ppc64el: enable PowerPC NX Crypto Coprocessor
    - Add support for uppercase and lowercase uuids.
    - Make busybox-initramfs a real runtime dependency, fixing kernel install
      failures with cryptsetup
    - init: Don't interpret "rootdelay" as a static sleep.
    - scripts/local: Let rootdelay determine the wait-for-root timeout.
    - Increase rootdelay to 180s on powerpc/ppc64/ppc64el
    - Support roottimeout= as the authoritative name for rootdelay= since the
      Ubuntu interpretation of rootdelay is *not* a delay and this causes
      inconsistent behavior depending on whether the kernel or an initramfs is
      interpreting it.
    - Revised mountroot failure support.  This is now deprecated and
      effectively removed.  However, to prevent breakage in other packages the
      add_mountroot_fail_hook function is still present as an empty stub.
    - Add a new 'fixrtc' script that tries to set the system clock forward
      based on the last mount time of the root disk; without this kludge,
      systems without a working RTC will end up in a perpetual reboot loop.
    - Restore the framebuffer hook and script, copying KMS and other
      framebuffer drivers into the initramfs, but make them optional; you need
      to set FRAMEBUFFER=y for these to be included.
    - netinfo_to_resolv_conf: Add support for IPv6
    - resume: only resume when the partition contains a resume image
    - Fix resuming a hibernate session from a swapfile
    - scripts/functions: by default, when setting up networking, use dhclient
      if we're asked to do DHCP explicitly, or if we otherwise are expected to
      do things automatically.
    - split out IPv6 options in its own cmdline parameter: ip6= ; always use
      dhclient in this case if the value set is anything other than 'off' or
      'none'. Furthermore, parse anything other than 'on', 'dhcp' or 'any' as
      the name of an interface.
    - rework the stop conditions so that we properly handle the ROUNDTTT loop,
      timing out after a short period of time and trying again after a short
      sleep.
    - add a 'done' parameter for both ip= and ip6= so that we can properly
      exit the ROUNDTTT loop once we know that either there is no work to do,
      or that we've achieved what we wanted (that is, to bring up IPv4, IPv6,
      or possibly both).
    - Just let dhclient scan the interfaces if none is specified for IPv6.
      (previously unnoted)
    - Do not handle ip=rarp specially (ipconfig hasn't supported it for some
      time)
    - Call dhclient in simple cases for IPv4 (this makes some small observable
      changes -- for example ip=bootp will now make a DHCP request too -- but
      nothing that seems important).
    - Do not let dhclient processes hang around past the pivot and have them
      respect the shorter timeouts ipconfig was given.
    - hook-functions, mkinitramfs, scripts/functions: support usage of dns
      after configure_networking.
    - Add unit tests for DNS support
    - scripts/functions: write netplan config files to /run/netplan for
      network devices configured with configure_networking.
    - Adjust testsuite for correct expected netplan output.
    - Add tests to parse netplan.yaml with netplan generate.
    - scripts/functions: include a new option to skip enslaved network
      devices.
    - Auto activate qeth devices on s390x hosts, when using ip= ip6= command
      lines.
    - Add support for creating VLANs via vlan=eth0.1:eth0 on kernel
      commandline, and as VLAN= conf.d snippet.
    - Emit empty dictionary in the ethernets section, for static vlan configs
      without any matches, as otherwise it is invalid config.
    - Skip attempting to chzdev enable VLAN device
    - Work out the kernel modules required to support ZFS filesystems and add
      them as necessary.
    - Add modules for nvme path components on multipath nvme.
    - Drop usage of klibc-utils' fstype in favor of always using udev blkid.
    - Use set -a/+a around loading conf snippets, to autoexport hook
      configuration variables. This thus allows packaged hooks to configure
      each other.


=== debian/control ===
Source: initramfs-tools
Section: utils
Priority: optional
Uploaders: Michael Prokop <mika@debian.org>, Ben Hutchings <benh@debian.org>
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
Build-Depends: bash-completion,
               debhelper-compat (= 13),
               libudev-dev,
               netplan.io [!i386] <!nocheck>,
               pkgconf,
               shellcheck [!i386] <!nocheck>,
               shunit2 <!nocheck>,
               udev [!i386] <!nocheck>
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/kernel-team/initramfs-tools
Vcs-Git: https://salsa.debian.org/kernel-team/initramfs-tools.git

Package: initramfs-tools
Architecture: all
Multi-Arch: foreign
Depends: initramfs-tools-core (= ${binary:Version}),
         linux-base,
         ${misc:Depends}
Suggests: bash-completion
Provides: linux-initramfs-tool
Conflicts: linux-initramfs-tool
Description: generic modular initramfs generator (automation)
 This package builds a bootable initramfs for Linux kernel packages.  The
 initramfs is loaded along with the kernel and is responsible for
 mounting the root filesystem and starting the main init system.

Package: initramfs-tools-core
Architecture: all
Multi-Arch: foreign
Recommends: zstd
Depends: coreutils (>= 8.24),
         cpio (>= 2.12),
         dhcpcd-base,
         dracut-install,
         e2fsprogs,
         initramfs-tools-bin (>= ${source:Version}),
         klibc-utils (>= 2.0.4-8~),
         kmod,
         logsave | e2fsprogs (<< 1.45.3-1~),
         udev,
         ${busybox:Depends},
         ${misc:Depends}
Suggests: 3cpio, bash-completion
Breaks: miniramfs (<< 1.0.3~)
Description: generic modular initramfs generator (core tools)
 This package contains the mkinitramfs program that can be used to
 create a bootable initramfs for a Linux kernel.  The initramfs should
 be loaded along with the kernel and is then responsible for mounting
 the root filesystem and starting the main init system.

Package: initramfs-tools-bin
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: initramfs-tools-core (<< 0.148~)
Replaces: initramfs-tools-core (<< 0.148~)
Description: generic modular initramfs generator (binary tools)
 This package contains binaries used inside the initramfs images generated
 by initramfs-tools. It also contains the unmkinitramfs program that can be
 used to unpack an initramfs image.

=== debian/tests/control ===
Tests: copy-file
Restrictions: needs-root, skip-not-installable, superficial, allow-stderr
Depends: linux-image-generic, zstd, @

Tests: unmkinitramfs
Restrictions: superficial
Depends: bzip2, xz-utils, lzop, lz4, zstd, @

Test-Command: debian/tests/unmkinitramfs
Restrictions: superficial
Depends: 3cpio, bzip2, xz-utils, lzop, lz4, zstd, @
Features: test-name=unmkinitramfs-3cpio

Test-Command: ./tests/run-tests
Depends: netplan.io, udev
Restrictions: allow-stderr
Features: test-name=unit-tests

Tests: qemu-klibc
Architecture: amd64 armhf s390x
Restrictions: needs-root
Depends: e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-arm [armhf],
         qemu-kvm,
         zstd,
         @

Tests: qemu-busybox
Architecture: amd64 armhf s390x
Restrictions: needs-root
Depends: busybox | busybox-initramfs,
         e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-arm [armhf],
         qemu-kvm,
         zstd,
         @

Tests: qemu-ata-only
Architecture: amd64
Restrictions: needs-root
Depends: e2fsprogs,
         genext2fs,
         klibc-utils,
         linux-image-generic,
         qemu-kvm,
         zstd,
         @

Tests: qemu-virtio-only qemu-separate-usr qemu-panic-shell
Architecture: amd64 arm64 armhf ppc64el s390x
Restrictions: needs-root
Depends: e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         zstd,
         @

Tests: qemu-net
Architecture: amd64 arm64 armhf ppc64el s390x
Restrictions: needs-root
Depends: e2fsprogs,
         genext2fs,
         iproute2,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         procps,
         python3,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         zstd,
         @

Tests: qemu-net-dnsmasq
Architecture: amd64 armhf s390x
Restrictions: needs-root
Depends: e2fsprogs,
         dnsmasq,
         genext2fs,
         iproute2,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         procps,
         python3,
         qemu-efi-arm [armhf],
         qemu-kvm,
         zstd,
         @

# qemu-net-iscsi fails on arm64: https://launchpad.net/bugs/2097568
Tests: qemu-net-iscsi
Architecture: amd64 armhf ppc64el s390x
Restrictions: needs-root
Depends: busybox | busybox-initramfs,
         dnsmasq,
         e2fsprogs,
         genext2fs,
         iproute2,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         open-iscsi,
         procps,
         python3,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         tgt,
         zstd,
         @

## initramfs-tools 0.150

=== Makefile ===
CFLAGS += -Wall -Wextra -O2

all: unmkinitramfs
clean:
	rm -f unmkinitramfs

.PHONY: all clean

=== debian/changelog ===
initramfs-tools (0.150) unstable; urgency=medium

  [ Benjamin Drung ]
  * [a6efee9] autopkgtest: replace qemu-kvm by qemu-system-native
  * [e1d0775] Revert "Avoid updating the initramfs twice for some cases"
    (Closes: #1108204)
  * [27544d4] update-initramfs: move "set -e" to the beginning
  * [afb3ba3] update-initramfs: use "set -u"
  * [f0c9c42] update-initramfs: add copyright information

  [ E Shattow ]
  * [d656783] hook-functions: Add Cadence USB driver to base (Closes:
    #1108924)

  [ Askar Safin ]
  * [7a9c2a0] hook-functions: add modules for non-default checksums on
    btrfs

  [ Ben Hutchings ]
  * [9fa9ae0] unmkinitramfs: Accept lower-case hex digits in cpio headers

 -- Ben Hutchings <benh@debian.org>  Tue, 12 Aug 2025 22:54:00 +0200

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,8 @@
 Section: utils
 Priority: optional
 Uploaders: Michael Prokop <mika@debian.org>, Ben Hutchings <benh@debian.org>
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
-Build-Depends: bash-completion,
-               debhelper-compat (= 13),
-               libudev-dev,
-               netplan.io [!i386] <!nocheck>,
-               pkgconf,
-               shellcheck [!i386] <!nocheck>,
-               shunit2 <!nocheck>,
-               udev [!i386] <!nocheck>
+Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
+Build-Depends: bash-completion, debhelper-compat (= 13), shunit2 <!nocheck>
 Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/kernel-team/initramfs-tools
@@ -34,20 +26,17 @@
 Package: initramfs-tools-core
 Architecture: all
 Multi-Arch: foreign
-Recommends: zstd
+Recommends: zstd, ${busybox:Recommends}
 Depends: coreutils (>= 8.24),
          cpio (>= 2.12),
-         dhcpcd-base,
          dracut-install,
-         e2fsprogs,
          initramfs-tools-bin (>= ${source:Version}),
          klibc-utils (>= 2.0.4-8~),
          kmod,
          logsave | e2fsprogs (<< 1.45.3-1~),
          udev,
-         ${busybox:Depends},
          ${misc:Depends}
-Suggests: 3cpio, bash-completion
+Suggests: bash-completion
 Breaks: miniramfs (<< 1.0.3~)
 Description: generic modular initramfs generator (core tools)
  This package contains the mkinitramfs program that can be used to
@@ -62,6 +51,5 @@
 Breaks: initramfs-tools-core (<< 0.148~)
 Replaces: initramfs-tools-core (<< 0.148~)
 Description: generic modular initramfs generator (binary tools)
- This package contains binaries used inside the initramfs images generated
- by initramfs-tools. It also contains the unmkinitramfs program that can be
- used to unpack an initramfs image.
+ This package contains the unmkinitramfs program that can be used to
+ unpack an initramfs image.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --with bash-completion

# On Debian we can use either busybox or busybox-static, but on Ubuntu
# and derivatives only busybox-initramfs will work.
BUSYBOX_PACKAGES := $(shell if dpkg-vendor --derives-from ubuntu; then echo busybox-initramfs; else echo busybox busybox-static; fi)

override_dh_gencontrol:
	echo >> debian/initramfs-tools-core.substvars "busybox:Recommends=$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=| %))"
	dh_gencontrol

override_dh_install:
	install -d debian/initramfs-tools-core/usr/sbin
	sed -e 's,@BUSYBOX_PACKAGES@,$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=or %)),;s,@VERSION@,$(DEB_VERSION),' \
		mkinitramfs > debian/initramfs-tools-core/usr/sbin/mkinitramfs
	chmod 755 debian/initramfs-tools-core/usr/sbin/mkinitramfs
	dh_install

override_dh_installinitramfs:
	@:

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	tests/functions_test
endif

=== debian/tests/control ===
Tests: copy-file
Restrictions: needs-root, breaks-testbed, skip-not-installable, superficial, allow-stderr
Depends: linux-image-generic, zstd, @

Tests: unmkinitramfs
Restrictions: superficial
Depends: bzip2, xz-utils, lzop, lz4, zstd, @

Tests: qemu-klibc
Architecture: amd64 armhf s390x
Restrictions: needs-root, breaks-testbed
Depends: e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-arm [armhf],
         qemu-system-native,
         zstd,
         @

Tests: qemu-busybox
Architecture: amd64 armhf s390x
Restrictions: needs-root, breaks-testbed
Depends: busybox | busybox-initramfs,
         e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-arm [armhf],
         qemu-system-native,
         zstd,
         @

Tests: qemu-ata-only
Architecture: amd64
Restrictions: needs-root, breaks-testbed
Depends: e2fsprogs,
         genext2fs,
         klibc-utils,
         linux-image-generic,
         qemu-system-native,
         zstd,
         @

Tests: qemu-virtio-only qemu-separate-usr qemu-panic-shell
Architecture: amd64 arm64 armhf ppc64el s390x
Restrictions: needs-root, breaks-testbed
Depends: e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-system-native,
         seabios [ppc64el],
         zstd,
         @

Tests: qemu-net
Architecture: amd64 arm64 armhf ppc64el s390x
Restrictions: needs-root, breaks-testbed
Depends: e2fsprogs,
         genext2fs,
         iproute2,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         procps,
         python3,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-system-native,
         seabios [ppc64el],
         zstd,
         @

Tests: qemu-net-iscsi
Architecture: amd64 arm64 armhf ppc64el s390x
Restrictions: breaks-testbed, needs-root
Depends: busybox | busybox-initramfs,
         dnsmasq,
         e2fsprogs,
         genext2fs,
         iproute2,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         open-iscsi,
         procps,
         python3,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-system-native,
         seabios [ppc64el],
         tgt,
         zstd,
         @

## initramfs-tools 0.150ubuntu1

=== debian/changelog ===
initramfs-tools (0.150ubuntu1) questing; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Use 3cpio for unmkinitramfs/lsinitramfs if available (for massive speedup)
      and let initramfs-tools-core suggest 3cpio
    - Harmonize kernel module installation with dracut's behavior:
      - Do not install ARM/RISCV specific modules on other architectures.
    - Revert "autopkgtest: Fix test failure when built-in drivers request
      firmware". This workaround is not needed on Ubuntu.
    - support mounting of loopback devices via loop*= parameters
    - Add vfat and nls modules to the initramfs.
    - Drop hooks/keymap, scripts/init-top/keymap, and associated code;
      console-setup takes care of this in Ubuntu.
    - Allow scripts and hooks to specify OPTION=VAR, and unless VAR is set to
      something other than "n", the script will not be included.
    - Add a new wait-for-root binary to the initramfs-tools-bin package that
      uses libudev to wait for udev to create the udev device, or wait for
      udev to finish processing if we catch it in the act, and returns the
      filesystem type as already probed by udev.
    - Automatically blacklist vga16fb when vga= or video= specified on kernel
      command-line.
    - Add hwaddr= alias for BOOTIF= for compatibility.
    - Set hostname at boot, for the benefit of mdadm autoassembly.
    - Add Hyper-V paravirtualised device drivers to the initramfs to allow
      booting of stock images in a Hyper-V guest.
    - ppc64el: enable PowerPC NX Crypto Coprocessor
    - Add support for uppercase and lowercase uuids.
    - Make busybox-initramfs a real runtime dependency, fixing kernel install
      failures with cryptsetup
    - init: Don't interpret "rootdelay" as a static sleep.
    - scripts/local: Let rootdelay determine the wait-for-root timeout.
    - Increase rootdelay to 180s on powerpc/ppc64/ppc64el
    - Support roottimeout= as the authoritative name for rootdelay= since the
      Ubuntu interpretation of rootdelay is *not* a delay and this causes
      inconsistent behavior depending on whether the kernel or an initramfs is
      interpreting it.
    - Revised mountroot failure support.  This is now deprecated and
      effectively removed.  However, to prevent breakage in other packages the
      add_mountroot_fail_hook function is still present as an empty stub.
    - Add a new 'fixrtc' script that tries to set the system clock forward
      based on the last mount time of the root disk; without this kludge,
      systems without a working RTC will end up in a perpetual reboot loop.
    - Restore the framebuffer hook and script, copying KMS and other
      framebuffer drivers into the initramfs, but make them optional; you need
      to set FRAMEBUFFER=y for these to be included.
    - netinfo_to_resolv_conf: Add support for IPv6
    - resume: only resume when the partition contains a resume image
    - Fix resuming a hibernate session from a swapfile
    - scripts/functions: by default, when setting up networking, use dhclient
      if we're asked to do DHCP explicitly, or if we otherwise are expected to
      do things automatically.
    - split out IPv6 options in its own cmdline parameter: ip6= ; always use
      dhclient in this case if the value set is anything other than 'off' or
      'none'. Furthermore, parse anything other than 'on', 'dhcp' or 'any' as
      the name of an interface.
    - rework the stop conditions so that we properly handle the ROUNDTTT loop,
      timing out after a short period of time and trying again after a short
      sleep.
    - add a 'done' parameter for both ip= and ip6= so that we can properly
      exit the ROUNDTTT loop once we know that either there is no work to do,
      or that we've achieved what we wanted (that is, to bring up IPv4, IPv6,
      or possibly both).
    - Just let dhclient scan the interfaces if none is specified for IPv6.
      (previously unnoted)
    - Do not handle ip=rarp specially (ipconfig hasn't supported it for some
      time)
    - Call dhclient in simple cases for IPv4 (this makes some small observable
      changes -- for example ip=bootp will now make a DHCP request too -- but
      nothing that seems important).
    - Do not let dhclient processes hang around past the pivot and have them
      respect the shorter timeouts ipconfig was given.
    - hook-functions, mkinitramfs, scripts/functions: support usage of dns
      after configure_networking.
    - Add unit tests for DNS support
    - scripts/functions: write netplan config files to /run/netplan for
      network devices configured with configure_networking.
    - Adjust testsuite for correct expected netplan output.
    - Add tests to parse netplan.yaml with netplan generate.
    - scripts/functions: include a new option to skip enslaved network
      devices.
    - Auto activate qeth devices on s390x hosts, when using ip= ip6= command
      lines.
    - Add support for creating VLANs via vlan=eth0.1:eth0 on kernel
      commandline, and as VLAN= conf.d snippet.
    - Emit empty dictionary in the ethernets section, for static vlan configs
      without any matches, as otherwise it is invalid config.
    - Skip attempting to chzdev enable VLAN device
    - Work out the kernel modules required to support ZFS filesystems and add
      them as necessary.
    - Add modules for nvme path components on multipath nvme.
    - Drop usage of klibc-utils' fstype in favor of always using udev blkid.
    - Use set -a/+a around loading conf snippets, to autoexport hook
      configuration variables. This thus allows packaged hooks to configure
      each other.
    - Fix PATH to include /usr/local.
    - Fix resume failure due to resume=UUID=... in certain cases
    - Always mount loop-mount filesystems read-write; ntfs-3g and vfat can't
      remount yet.
    - Provide a clearer error on mount failure of the Windows host filesystem


## initramfs-tools 0.150ubuntu2

=== debian/changelog ===
initramfs-tools (0.150ubuntu2) questing; urgency=medium

  * Revert making 3cpio the default cpio tool since it is too late for the
    questing release cycle.

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 16 Sep 2025 11:27:35 +0200

## initramfs-tools 0.150ubuntu3

=== Makefile ===
CFLAGS += -Wall -Wextra -O2
PKG_CONFIG ?= pkg-config
UDEV_CFLAGS = $(shell $(PKG_CONFIG) --cflags libudev)
UDEV_LIBS = $(shell $(PKG_CONFIG) --libs libudev)

all: gcc_s1-stub unmkinitramfs wait-for-root
clean:
	rm -f gcc_s1-stub unmkinitramfs wait-for-root

gcc_s1-stub:
	$(CC) -Wl,--no-as-needed -shared -l:libpthread.so.0 -l:libgcc_s.so.1 -o $@

wait-for-root: wait-for-root.c
	$(CC) $(CFLAGS) $(UDEV_CFLAGS) $(LDFLAGS) -o $@ $< $(UDEV_LIBS)

.PHONY: all clean

=== debian/changelog ===
initramfs-tools (0.150ubuntu3) questing; urgency=medium

  * Explicitly include xhci-pci-renesas (LP: #2126559)

 -- Thibault Ferrante <thibault.ferrante@canonical.com>  Wed, 01 Oct 2025 15:00:05 +0200

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,12 @@
 #!/usr/bin/make -f
 
+include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
+
+ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
+export CC=$(DEB_HOST_GNU_TYPE)-gcc
+export PKG_CONFIG=$(DEB_HOST_GNU_TYPE)-pkg-config
+endif
 
 %:
 	dh $@ --with bash-completion
@@ -10,7 +16,7 @@
 BUSYBOX_PACKAGES := $(shell if dpkg-vendor --derives-from ubuntu; then echo busybox-initramfs; else echo busybox busybox-static; fi)
 
 override_dh_gencontrol:
-	echo >> debian/initramfs-tools-core.substvars "busybox:Recommends=$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=| %))"
+	echo >> debian/initramfs-tools-core.substvars "busybox:Depends=$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=| %))"
 	dh_gencontrol
 
 override_dh_install:
@@ -25,5 +31,9 @@
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+    ifeq (,$(filter i386,$(DEB_HOST_ARCH)))
+	shellcheck hook-functions $$(find hooks scripts -type f) $$({ find . -maxdepth 1 -type f -executable; find debian -maxdepth 1 -type f; find debian/tests docs kernel tests -type f; } | xargs grep -l '^#!/bin/sh')
+    endif
 	tests/functions_test
+	./tests/run-tests
 endif

## initramfs-tools 0.150ubuntu3.1

=== debian/changelog ===
initramfs-tools (0.150ubuntu3.1) questing; urgency=medium

  * mkinitramfs: do not set pigz as compression for 3cpio (LP: #2130550)

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 12 Nov 2025 13:58:16 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,16 @@
 Section: utils
 Priority: optional
 Uploaders: Michael Prokop <mika@debian.org>, Ben Hutchings <benh@debian.org>
-Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
-Build-Depends: bash-completion, debhelper-compat (= 13), shunit2 <!nocheck>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
+Build-Depends: bash-completion,
+               debhelper-compat (= 13),
+               libudev-dev,
+               netplan.io [!i386] <!nocheck>,
+               pkgconf,
+               shellcheck [!i386] <!nocheck>,
+               shunit2 <!nocheck>,
+               udev [!i386] <!nocheck>
 Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/kernel-team/initramfs-tools
@@ -26,15 +34,18 @@
 Package: initramfs-tools-core
 Architecture: all
 Multi-Arch: foreign
-Recommends: zstd, ${busybox:Recommends}
+Recommends: zstd
 Depends: coreutils (>= 8.24),
-         cpio (>= 2.12),
+         cpio (>= 2.12) | 3cpio (>= 0.7),
+         dhcpcd-base,
          dracut-install,
+         e2fsprogs,
          initramfs-tools-bin (>= ${source:Version}),
          klibc-utils (>= 2.0.4-8~),
          kmod,
          logsave | e2fsprogs (<< 1.45.3-1~),
          udev,
+         ${busybox:Depends},
          ${misc:Depends}
 Suggests: bash-completion
 Breaks: miniramfs (<< 1.0.3~)
@@ -51,5 +62,6 @@
 Breaks: initramfs-tools-core (<< 0.148~)
 Replaces: initramfs-tools-core (<< 0.148~)
 Description: generic modular initramfs generator (binary tools)
- This package contains the unmkinitramfs program that can be used to
- unpack an initramfs image.
+ This package contains binaries used inside the initramfs images generated
+ by initramfs-tools. It also contains the unmkinitramfs program that can be
+ used to unpack an initramfs image.

## initramfs-tools 0.150ubuntu4

=== debian/changelog ===
initramfs-tools (0.150ubuntu4) resolute; urgency=medium

  * Drop supporting cpio and rely on 3cpio

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 21 Oct 2025 10:57:06 +0200

=== debian/control ===
--- 
+++ 
@@ -35,8 +35,8 @@
 Architecture: all
 Multi-Arch: foreign
 Recommends: zstd
-Depends: coreutils (>= 8.24),
-         cpio (>= 2.12) | 3cpio (>= 0.7),
+Depends: 3cpio (>= 0.7),
+         coreutils (>= 8.24),
          dhcpcd-base,
          dracut-install,
          e2fsprogs,
@@ -48,7 +48,7 @@
          ${busybox:Depends},
          ${misc:Depends}
 Suggests: bash-completion
-Breaks: miniramfs (<< 1.0.3~)
+Breaks: amd64-microcode (<< 3.20250311.1ubuntu2~), miniramfs (<< 1.0.3~)
 Description: generic modular initramfs generator (core tools)
  This package contains the mkinitramfs program that can be used to
  create a bootable initramfs for a Linux kernel.  The initramfs should

=== debian/tests/control ===
--- 
+++ 
@@ -1,14 +1,19 @@
 Tests: copy-file
-Restrictions: needs-root, breaks-testbed, skip-not-installable, superficial, allow-stderr
+Restrictions: needs-root, skip-not-installable, superficial, allow-stderr
 Depends: linux-image-generic, zstd, @
 
 Tests: unmkinitramfs
 Restrictions: superficial
 Depends: bzip2, xz-utils, lzop, lz4, zstd, @
 
+Test-Command: ./tests/run-tests
+Depends: netplan.io, udev
+Restrictions: allow-stderr
+Features: test-name=unit-tests
+
 Tests: qemu-klibc
 Architecture: amd64 armhf s390x
-Restrictions: needs-root, breaks-testbed
+Restrictions: needs-root
 Depends: e2fsprogs,
          genext2fs,
          ipxe-qemu,
@@ -21,7 +26,7 @@
 
 Tests: qemu-busybox
 Architecture: amd64 armhf s390x
-Restrictions: needs-root, breaks-testbed
+Restrictions: needs-root
 Depends: busybox | busybox-initramfs,
          e2fsprogs,
          genext2fs,
@@ -35,7 +40,7 @@
 
 Tests: qemu-ata-only
 Architecture: amd64
-Restrictions: needs-root, breaks-testbed
+Restrictions: needs-root
 Depends: e2fsprogs,
          genext2fs,
          klibc-utils,
@@ -46,7 +51,7 @@
 
 Tests: qemu-virtio-only qemu-separate-usr qemu-panic-shell
 Architecture: amd64 arm64 armhf ppc64el s390x
-Restrictions: needs-root, breaks-testbed
+Restrictions: needs-root
 Depends: e2fsprogs,
          genext2fs,
          ipxe-qemu,
@@ -61,7 +66,7 @@
 
 Tests: qemu-net
 Architecture: amd64 arm64 armhf ppc64el s390x
-Restrictions: needs-root, breaks-testbed
+Restrictions: needs-root
 Depends: e2fsprogs,
          genext2fs,
          iproute2,
@@ -77,9 +82,27 @@
          zstd,
          @
 
+Tests: qemu-net-dnsmasq
+Architecture: amd64 armhf s390x
+Restrictions: needs-root
+Depends: e2fsprogs,
+         dnsmasq,
+         genext2fs,
+         iproute2,
+         ipxe-qemu,
+         klibc-utils,
+         linux-image-generic,
+         procps,
+         python3,
+         qemu-efi-arm [armhf],
+         qemu-system-native,
+         zstd,
+         @
+
+# qemu-net-iscsi fails on arm64: https://launchpad.net/bugs/2097568
 Tests: qemu-net-iscsi
-Architecture: amd64 arm64 armhf ppc64el s390x
-Restrictions: breaks-testbed, needs-root
+Architecture: amd64 armhf ppc64el s390x
+Restrictions: needs-root
 Depends: busybox | busybox-initramfs,
          dnsmasq,
          e2fsprogs,
@@ -98,3 +121,7 @@
          tgt,
          zstd,
          @
+
+# Dummy test so that linux-firmware updates trigger our other autopkgtests
+Features: test-name=hint-testsuite-triggers
+Test-Command: false

## initramfs-tools 0.150ubuntu5

=== debian/changelog ===
initramfs-tools (0.150ubuntu5) resolute; urgency=medium

  * Fix shellcheck 0.11.0 complaints
  * mkinitramfs: do not set pigz as compression for 3cpio (LP: #2130550)

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 12 Nov 2025 13:06:35 +0100

## initramfs-tools 0.150ubuntu6

=== debian/changelog ===
initramfs-tools (0.150ubuntu6) resolute; urgency=medium

  * autopkgtest: increase timeout to 240s on s390x

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 09 Dec 2025 17:30:31 +0100

## initramfs-tools 0.150ubuntu7

=== debian/changelog ===
initramfs-tools (0.150ubuntu7) resolute; urgency=medium

  [ Benjamin Drung ]
  * hooks/dhcpcd: support /usr/libexec as hooks path (LP: #2137657)
  * Do not run netplan integration tests during build (rely on autopkgtest)

  [ John Chittum ]
  * autopkgtest: make root more explicit. full paths including /dev or
    LABEL= for multi-drive boot in qemu-net-iscsi (LP: #2134531)

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 12 Jan 2026 13:55:50 +0100

=== debian/rules ===
--- 
+++ 
@@ -35,5 +35,4 @@
 	shellcheck hook-functions $$(find hooks scripts -type f) $$({ find . -maxdepth 1 -type f -executable; find debian -maxdepth 1 -type f; find debian/tests docs kernel tests -type f; } | xargs grep -l '^#!/bin/sh')
     endif
 	tests/functions_test
-	./tests/run-tests
 endif

## initramfs-tools 0.150ubuntu8

=== debian/changelog ===
initramfs-tools (0.150ubuntu8) resolute; urgency=medium

  * d/t/run-qemu: fix arm64 tests failure because of cpu=max
    (LP: #2142121)

 -- Hector Cao <hector.cao@canonical.com>  Fri, 27 Feb 2026 11:57:35 +0100
